Subject: bug#24050: 24.5; ispell-change-dictionary suggests non-existent dicts (aspell)

From: Lars Ingebrigtsen <[email-masked]>
Date: Sun, 28 Jul 2019 12:25:16 +0200

Ole Jørgen Brønner <[email-masked]> writes:

> There's a dedicated function, `ispell-find-aspell-dictionaries`, to find valid
> aspell dictionaries. It sanely ask bin/aspell for the list and then does some
> post-processing to find the rest of the spec.
>
> But after the *correct* list has been found this code[1] is run:
>
>     ;; Merge into FOUND any elements from the standard
> ispell-dictionary-base-alist
>     ;; which have no element in FOUND at all.
>     (dolist (dict ispell-dictionary-base-alist)
>       (unless (assoc (car dict) found)
>     (setq found (nconc found (list dict)))))
>
> Adding invalid entries to the list. There might be a rationale behind that, but
> to me is seems like `ispell-dictionary-base-alist` mostly exist due to lack of
> *ispell* (old aspell?) introspection? (When using *ispell* as the
> provider, invalid entries
>  are filtered out in `ispell-valid-dictionary-list`)
>
> Removing that code isn't enough though:
>
> In `ispell-set-spellchecker-params` the invalid entries are added again:
> (where `found-dicts-alist` is the result of `ispell-find-aspell-dictionaries`
> in when aspell is used)
>
>     (run-hooks 'ispell-initialize-spellchecker-hook)
>
>     ;; Add dicts to ``ispell-dictionary-alist'' unless already present.
>     (dolist (dict (append found-dicts-alist
>                           ispell-base-dicts-override-alist
>                           ispell-dictionary-base-alist))
>       (unless (assoc (car dict) all-dicts-alist)
>         (add-to-list 'all-dicts-alist dict)))
>     (setq ispell-dictionary-alist all-dicts-alist))
>
> This code seems to have two purposes:
> - When *ispell* is the provider, `found-dicts-alist` is nil at this
> point, so the
>   default entries must be added
> - Apply dictionary overrides (possibly set by the hook above)

(I'm going through old Emacs bug reports that haven't received any
response.)

Thanks for the analysis; altering the code along these lines does fix
the problem, and `M-x ispell-change-dictionary' now seems a lot more
useful now that it just lists the dictionaries I actually have
installed.

> I would suggest simply removing [1] and not add the *base-alist above when using
> aspell/hunspell, but the following comment makes it seem like the "invalid"
> entries are added intentionally:
>
>     ;; Substitute ispell-dictionary-alist with the list of
>     ;; dictionaries corresponding to the given spellchecker.
>     ;; If a recent aspell or hunspell, use the list of really
>     ;; installed dictionaries and add to it elements of the original
>     ;; list that are not present there*. Allow distro info.

It may be intentional, but the other comments seem to indicate that it's
not...  and I don't see the utility of listing dictionaries we don't
have, so I think it's a good change anyway.

So I've made it on the Emacs trunk now.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no